unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, shellapi, StdCtrls, ComCtrls, Buttons, dateutils;

type
  TformMenuPrincipal = class(TForm)
    DateTimePicker1: TDateTimePicker;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    tabCalendario: TTabSheet;
    MonthCalendar1: TMonthCalendar;
    LWEB: TLabel;
    GroupBox1: TGroupBox;
    txtFechaInicio: TDateTimePicker;
    Label1: TLabel;
    txtFechaFin: TDateTimePicker;
    Label2: TLabel;
    Label3: TLabel;
    bCalcular: TBitBtn;
    mResultado: TMemo;
    procedure LWEBClick(Sender: TObject);
    procedure bCalcularClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

function anosMesesDias(fechaInicio : TDate;
    fechaFin : TDate) : string;
var
  anos, meses, dias, m : Integer;
begin
  anos := YearOf (fechaFin) - YearOf (fechaInicio);
  if MonthOf (fechaInicio) > MonthOf (fechaFin) then
    anos := anos - 1;
  if MonthOf (fechaFin) < MonthOf (fechaInicio) then
    meses := 12 - MonthOf (fechaInicio) + MonthOf (fechaFin)
  else
    meses := MonthOf (fechaFin) - MonthOf (fechaInicio);
  if DayOf (fechaFin) < DayOf (fechaInicio) then
  begin
    meses := meses - 1;
    if MonthOf (fechaFin) = MonthOf (fechaInicio) then
    begin
      anos := anos - 1;
      meses := 11;
    end;
  end;
  dias := DayOf (fechaFin) - DayOf (fechaInicio);
  if dias < 0 then
  begin
    m := MonthOf (fechaFin) - 1;
    if m = 0 then
      m := 12;
    case m of
      1, 3, 5, 7, 8, 10, 12 : dias := 31 + dias;
      4, 6, 9, 11 : dias := 30 + dias;
      2 :
      begin
        if ((YearOf(fechaFin) mod 4 = 0) and
            (YearOf(fechaFin) mod 100 <> 0))
            or (YearOf(fechaFin) mod 400 = 0) then
          dias := 29 + dias
        else
          dias := 28 + dias;
      end;
    end;
  end;
  result := IntToStr (anos) + ' aos, ' +
      IntToStr (meses) + ' meses, ' +
      IntToStr (dias) + ' das';
end;

function fechaJuliana (fecha : TDate) : integer;
begin
  Result:= trunc(fecha - StrToDate(FormatDateTime('01/01/yyyy', fecha))) + 1;
end;

function diaSemanaTexto (fecha : TDateTime) : string;
var
  dia : integer;
begin
  dia := DayOfTheWeek (fecha);
  case dia of
    1 : Result := 'lunes';
    2 : Result := 'martes';
    3 : Result := 'mircoles';
    4 : Result := 'jueves';
    5 : Result := 'viernes';
    6 : Result := 'sbado';
    7 : Result := 'domingo';
  else
    Result := 'Error';
  end;
end;

function numeroSemana (fecha : TDateTime) : Word;
var
  Y, M, D : Word;
  dtTmp : TDateTime;
begin
  DecodeDate(fecha, Y, M, D) ;
  dtTmp := EnCodeDate(Y, 1, 1) ;
  Result := (Trunc(fecha - dtTmp) + (DayOfWeek(dtTmp) - 1)) div 7;
  if Result <> 0 then
    Result := Result - 1;
end;


procedure TformMenuPrincipal.bCalcularClick(Sender: TObject);
begin
  if txtFechaInicio.DateTime <= txtFechaFin.DateTime then
  begin
    mResultado.Clear;
    mResultado.Lines.Add('---- INTERVALO ----');
    mResultado.Lines.Add('Intervalo en aos, meses y das: ' +
        anosMesesDias (txtFechaInicio.DateTime, txtFechaFin.DateTime));
    mResultado.Lines.Add('Nmero de aos: ' +
        inttostr(YearsBetween(txtFechaInicio.DateTime, txtFechaFin.Date)));
    mResultado.Lines.Add('Nmero de meses: ' +
        inttostr(MonthsBetween(txtFechaInicio.DateTime, txtFechaFin.Date)));
    mResultado.Lines.Add('Nmero de das: ' +
        inttostr(DaysBetween(txtFechaInicio.DateTime, txtFechaFin.Date)));

    mResultado.Lines.Add('');
    mResultado.Lines.Add('');
    mResultado.Lines.Add('---- FECHA ' +
        DateToStr(txtFechaInicio.Date) + ' ----');
    mResultado.Lines.Add('Nmero de das transcurridos desde inicio de ao: ' +
        IntToStr(fechaJuliana(txtFechaInicio.DateTime)));
    mResultado.Lines.Add('Nmero de das que quedan para finalizar el ao: ' +
        IntToStr(DaysInYear(txtFechaInicio.DateTime) -
        fechaJuliana(txtFechaInicio.DateTime)));
    mResultado.Lines.Add('Nmero de das transcurridos desde inicio de mes: ' +
        IntToStr(DayOf(txtFechaInicio.DateTime)));
    mResultado.Lines.Add('Nmero de das del ao ' +
        IntToStr(YearOf(txtFechaInicio.DateTime)) + ': ' +
        IntToStr(DaysInYear(txtFechaInicio.DateTime)));
    mResultado.Lines.Add('Da de la semana (texto): ' +
        diaSemanaTexto(txtFechaInicio.DateTime));
    mResultado.Lines.Add('Da de la semana (nmero): ' +
        IntToStr(DayOfTheWeek(txtFechaInicio.DateTime)));
    mResultado.Lines.Add('Nmero de semanas transcurridas desde inicio de ao: ' +
        IntToStr(numeroSemana(txtFechaInicio.DateTime)));


  end
  else
  begin
    MessageDlg('La fecha de inicio no puede ser superior a la fecha de fin.',
        mtInformation, [mbok], 0);
    txtFechaInicio.SetFocus;
  end;
end;

end.
